@echo off
%~d0%
cd %~p0%

title "BatchXSLTJavaStarter"

set tasklistpath=""
rem FIRST TEST if tasklist.exe is available!!
tasklist /FI "IMAGENAME eq java.exe" >NUL 2>NUL
if "%errorlevel%"=="9009" set tasklistpath=Utilities\win\

%tasklistpath%tasklist /FI "IMAGENAME eq java.exe" 2>NUL | find /I /N "java.exe">NUL
if "%ERRORLEVEL%"=="0" ( set javarunning=1 ) else ( set javarunning=0 )
%tasklistpath%tasklist /FI "WINDOWTITLE eq BatchXSLT*" 2>NUL /FI "IMAGENAME eq java.exe" 2>NUL  | find /I /N "java.exe">NUL
if "%ERRORLEVEL%"=="0" ( set batchxsltrunning=1 ) else ( set batchxsltrunning=0 )

if %javarunning%==1 (
    echo Java definitely is running
    if %batchxsltrunning%==1 (
    	rem echo BatchXSLT definitely is running
        exit
    ) else goto startit
)

:startit
echo Calling BatchXSLT from drive %~d0%
echo    path: %~p0%

set bxsltUserPath=%USERPROFILE%\BatchXSLT4InDesignComm\BatchXSLT
if not exist "%bxsltUserPath%" mkdir "%bxsltUserPath%" 

echo    comm: %bxsltUserPath%
echo BatchXSLT is running. Delete this file if it is not > "%bxsltUserPath%\batchxsltisrunning"

set orig_PATH=%PATH%
set orig_JAVA_HOME=%JAVA_HOME%
set orig_CLASSPATH=%CLASSPATH%

set JAVA_HOME=%~d0%~p0%BatchXSLT.app\Contents\PlugIns\JavaVM
set PATH=%JAVA_HOME%\bin;%PATH%;
set CLASSPATH=%~d0%~p0%BatchXSLT.app\Contents\Java

if exist "%~d0%~p0%BatchXSLT.app\Contents\PlugIns\JavaVM\bin\java.exe" (
  rem found bundled java.exe
  rem echo File exists
  goto runit
)

rem no bundled java - try to call system installed java
rem reset java environment
rem echo File does not exist
set PATH=%orig_PATH%
set JAVA_HOME=%orig_JAVA_HOME%
set CLASSPATH=%orig_CLASSPATH%
rem call java - may be installed java can be found - see blow



:runit
echo __________________________________________________________________
echo DO NOT CLOSE THIS WINDOW. INSTEAD CLOSE THE "BatchXSLT application"
echo __________________________________________________________________

java.exe -Xms384m -Xss12m -Dfile.encoding=UTF8 -jar BatchXSLT.app/Contents/Java/BatchXSLT.jar


if "%errorlevel%"=="0" goto gohome
if "%errorlevel%"=="1" goto error1
if "%errorlevel%"=="9009" goto error9009

@echo ###
@echo ###    Un unexpected ERROR %errorlevel% occured!
pause
goto gohome


:error1
@echo ###
@echo ###    ERROR %errorlevel% ===============
@echo ###    ERROR 1 can have several reasons:
@echo ###
@echo ###    1. INSTALL JAVA 1.9 or newer if above trace starts with:
@echo ###       Exception in thread "main" java.lang.UnsupportedClassVersionError:
@echo ###         com/epaperarchives/batchxslt/BatchXSLT
@echo ###         (Unsupported major.minor version 49.0)
@echo ###       ----
@echo ###
@echo ###    2. The BatchXSLT jar libraries could not be found 
@echo ###       if above trace starts with:
@echo ###       "Unable to access jarfile"
@echo ###       "  BatchXSLT.app/Contents/Java/BatchXSLT.jar"
@echo ###       make sure that this path:
@echo ###       %0
@echo ###       points to the installation directory of BatchXSLT
@echo ###       ----
goto dopause


:error9009
@echo ###
@echo ###    ERROR %errorlevel% ===============
@echo ###    ERROR %errorlevel% can have several reasons:
@echo ###
@echo ###    1. INSTALL JAVA 1.9 or newer if above trace is similar to:
@echo ###       The command java.exe could not be found
@echo ###       ----
@echo ###
@echo ###    2. INSTALL JAVA 1.9 or newer if above trace starts with:
@echo ###       Exception in thread "main" java.lang.UnsupportedClassVersionError:
@echo ###         com/epaperarchives/batchxslt/BatchXSLT
@echo ###         (Unsupported major.minor version XX.X)
@echo ###       ----
@echo ###
@echo ###    3. The BatchXSLT jar libraries could not be found 
@echo ###       if above trace starts with:
@echo ###       "Unable to access jarfile"
@echo ###       "  BatchXSLT.app/Contents/Java/BatchXSLT.jar"
@echo ###       make sure that this path:
@echo ###       %0
@echo ###       points to the installation directory of BatchXSLT
@echo ###       ----
goto dopause

:dopause
pause

:gohome
if exist "%bxsltUserPath%\batchxsltisrunning" del "%bxsltUserPath%\batchxsltisrunning"
exit

